-- faster vehicle Camera movement for analog axis input
--
-- author: upsidedown
-- 
-- 21.08.2013
-- converted to LS15: 1.11.2014
-- converted to LS17: 29.10.16

camMod = {};

local camFac_global = 5.0;
local camFac_analogX = 1.5;
local camFac_analogY = 0.2;
local camFac_mouseX = 2.5;
local camFac_mouseY = 1.5;



local oldCamReset = VehicleCamera.resetCamera;
VehicleCamera.resetCamera = function (self)
	if false then --flag from xml
		oldCamReset(self);
	end;
end;

local oldVehicleCamUpdate = VehicleCamera.update;
VehicleCamera.update = function (self, dt)
	if self.isActivated then
		InputBinding.actions[InputBinding.AXIS_LOOK_LEFTRIGHT_VEHICLE].lastInputAxis = camFac_analogX*InputBinding.actions[InputBinding.AXIS_LOOK_LEFTRIGHT_VEHICLE].lastInputAxis;
		InputBinding.actions[InputBinding.AXIS_LOOK_UPDOWN_VEHICLE].lastInputAxis = camFac_analogY*InputBinding.actions[InputBinding.AXIS_LOOK_UPDOWN_VEHICLE].lastInputAxis;
	end;	

	oldVehicleCamUpdate(self, camFac_global*dt)
	if self.isActivated then
		if InputBinding.hasEvent(InputBinding.DC_cam_reset) then
			oldCamReset(self);
		end;
		
		if self.fovResetTimer == nil then
			self.fovResetTimer = 0;
		end;
		if self.resetFov == nil then
			self.resetFov = getFovy(self.cameraNode);
		end;
		
		if self.fovResetTimer <= 0 then
			local fovSpeed = 5e-3;
			if InputBinding.isPressed(InputBinding.DC_cam_FOVplus) and InputBinding.isPressed(InputBinding.DC_cam_FOVminus) then
				self.fovResetTimer = 800;
			elseif InputBinding.isPressed(InputBinding.DC_cam_FOVplus) then
				local fov = getFovy(self.cameraNode);
				fov = fov + fovSpeed*dt
				fov = math.min(fov,110);
				setFovy(self.cameraNode,fov)				
			elseif InputBinding.isPressed(InputBinding.DC_cam_FOVminus) then
				local fov = getFovy(self.cameraNode);
				fov = fov - fovSpeed*dt
				fov = math.max(fov,30);
				setFovy(self.cameraNode,fov)
			end;
		else
			self.fovResetTimer = self.fovResetTimer - dt;
			setFovy(self.cameraNode,self.resetFov);
		end;
		
	end;
end;

local oldCamMouse = VehicleCamera.mouseEvent;
VehicleCamera.mouseEvent = function (self, posX, posY, isDown, isUp, button)
	if self.isActivated then
		local oldX = InputBinding.mouseMovementX;
		local oldY = InputBinding.mouseMovementY;
		InputBinding.mouseMovementX = InputBinding.mouseMovementX*camFac_global*camFac_mouseX;
		InputBinding.mouseMovementY = InputBinding.mouseMovementY*camFac_global*camFac_mouseY;
		oldCamMouse(self, posX, posY, isDown, isUp, button);
		InputBinding.mouseMovementX = oldX;
		InputBinding.mouseMovementY = oldY;
	end;
end;

-- to DO: 
-- a) save/load FOV
-- b) load from xml